Welcome to Web Reporting Administration

Welcome! This section introduces you to Seagate Software's web reporting solution and provides an outline of the information contained in this guide.

Seagate Software, Inc.
http://www.seagatesoftware.com
Please send comments to:
techpubs@seagatesoftware.com


Welcome

Seagate Software provides a comprehensive web reporting solution with the Professional and Developer edition of Seagate Crystal Reports. These products work together with your existing Intranet/Extranet to provide web access to Seagate Crystal Reports.


About the online help

This guide includes procedures for installing, configuring and administering the Web Component Server and associated web products.


Section contents

The following is a short description of each chapter in this guide.

Welcome to Web Reporting Administration

This section provides an overview of the user's guide and online help. It also lists the command, button, and key conventions used in the user's guide.

Web Reporting Solution Overview

This section identifies how Seagate's web products work together with your existing web server. Information about new features and enhancements is also included.

Web Component Server Implementation

This section contains the procedural information required to install and configure the Web Component Server.

Web Component Server Administration

This section provides details about how to use the Crystal Web Components Manager application included with the Web Component Server. Using this application you can customize the settings of the Web Component Server.

Web Component Server Commands

This section provides examples of Web Component Server commands that can be appended to URL requests. These URL requests can be used to prompt users to enter security information or parameter field values.

Report Viewers

This section contains information about how to configure Report Viewers to effectively meet the needs of your users.

Product Support

This appendix lists methods and contact information for obtaining product support.

Seagate Software International Office Directory

This appendix provides contact numbers for Sales and Product Support for Seagate Software offices, worldwide.


Using the online help

The online help contains all of the information found in the guide as well as additional reference material. For example, in the online help you can find information about how to configure a Lotus Domino server to work with the Web Component Server.

Access Online Help related to the Seagate's Web Reporting solution by launching the Crystal Report Web Components Manager application.

Use the Contents tab to view all major sections in the online help and drill down to specific headings within each section. Use the Index tab to view topics in alphabetical order and the Search tab to enter a keyword or to view all of the sections that relate to the keyword.


Command, button, and key conventions

Commands and buttons

For easy recognition, command names and button names are displayed in bold. For example: Next command, Print button, and so on.

Key combinations

Keyboard shortcuts appear in the following forms:

  • Delete means the Del key (either the Delete key, or the Del key on your numeric keypad).
  • Enter means the Enter, Return, or CR depending on which of these keys appears on your keyboard.
  • Ctrl-Key, Shift-Key, and Alt-Key are examples of the notation for two-key combinations. Press the first key in the combination (Control, Shift, or Alt) and, at the same time, press the second key in the combination (designated above as Key). For example: Ctrl-C means to hold the Control key down, and then press the letter C on your keyboard (Ctrl-C is the Windows Copy command.)

Other conventions

  • Courier font indicates data that you enter using your keyboard.


Web Reporting Solution Overview

In addition to feature descriptions, this section includes information about how Seagate's web products work together with your web server to provide access to Seagate Crystal Reports over the web.


Web product features

Efficient delivery of report pages

To efficiently deliver reports, the Web Component Server uses the Page On Demand feature. This feature enables report pages to be delivered when requested. Sometimes a user may only need one or two pages of information out of a 100 page report. Rather than tie up your network by frequently transferring massive amounts of data, the Web Component Server delivers reports a page at a time as requested by the client.

When a report page is requested the first time the report is generated, the requested page is delivered to the client and stored in a cache. The next time the client requests the same page it is retrieved from the cache rather than being generated again.

By handling requests on a per page basis, the Web Component Server can quickly handle large numbers of requests, limiting the delay in delivery for any one single request. Caching report pages also allows report information to be shared among clients more efficiently as multiple requests for the same report do not require the report to be generated multiple times.

Ability to drill down for more information

To easily find information, you can let users access the navigation tree. The navigation tree, which is similar to the Windows Explorer, appears within your web browser along with the appropriate Report Viewer. This enables users to expand groups and view the records associated with each of the groups. This quickly directs the user to the information they are interested in, instead of flipping through each page of the report.

Works with your database security

Seagate Crystal Reports continues to support the security procedures you have already established over the web through the use of the Web Component Server. The Web Component Server automatically recognizes the security you have established and prompts users for IDs and passwords for reports that use ODBC and SQL data sources.

Or as an alternative, you can use the Web Component Server commands to automatically handle security through hyperlinks or other web links to reports.

Supports stored procedures and parameter fields

Stored procedures often improve performance and data selection in large SQL databases. Additionally, Seagate Crystal Reports parameter fields can provide on-the-fly data selection inside your reports. Both of these powerful features are supported by the Web Component Server.

If your reports are based on stored procedures, or if they include Seagate Crystal Reports parameter fields, the Web Component Server automatically prompts users for parameter values when the report is generated. URL parameters in hyperlinks or HTML forms can also specify values for parameter fields or stored procedures.

Exploits Microsoft and Netscape web server extensions

If you are using a Microsoft or Netscape web server to distribute reports, the Web Component Server can directly exploit the power of your web server through the ISAPI or NSAPI programming interfaces. The Web Component Server supports both APIs in a single file: wcsinsapi.dll. The APIs improve web application performance through direct extensions to the web server itself.

For more information on ISAPI, refer to Microsoft documentation. For more information on NSAPI, refer to Netscape documentation.


Works with a variety of browsers

The Web Component Server handles report generation and distribution on the server side. The user, however, views a report using one of the Report Viewers. These browser-based viewers provide complete access to report information without the need for installing any additional applications on the client machine other than a web browser.

There are six report viewers included with Seagate Crystal Reports. These are:

  • Report Viewer for ActiveX
  • Report Viewer for Java using Browser JVM
  • Report Viewer for Java using Java Plug-in
  • Report Viewer for Netscape Plug-in
  • Report Viewer for Standard HTML with Frames
  • Report Viewer for Standard HTML.

Each viewer has its advantages, and you can choose the viewer that works best for your web site. If you do not specify a viewer, the Web Component Server automatically specifies a viewer based on the web browser used to request the report.

Web Browser | Default Report Viewer
Internet Explorer 4.0 | Report Viewer for ActiveX
Netscape Navigator 3.0 | Report Viewer for HTML
Netscape Navigator 4.0 | Report Viewer for Java


Report Viewer for ActiveX

The Report Viewer for ActiveX is a standard ActiveX control that also displays reports using the Encapsulated Page File (EPF) format.


Report Viewers for Java

The Java-based viewers sit inside an HTML page as a standard Java applet. Reports are displayed inside the Java viewer using the advanced EPF format. EPF is a report format that retains almost all of the original report formatting options and settings while producing files that are smaller than HTML files. The result is faster access to reports.


Report Viewer for Netscape Plug-in

The Report Viewer for Netscape Plug-in displays reports using the EPF format.


Report Viewers for HTML

The Report Viewers for HTML are based on the HTML 4.0 standard, delivering reports in plain HTML format or HTML with frames. These viewers can be used on any web browser that supports the HTML 4.0 standard.


New features in version 8

Version 8 of Seagate Crystal Reports includes several new features to improve Web Component Server options, accessibility, and performance.

Introduction of placeholders

With the use of placeholders, you are able to download partial EPFs and view the rest of the content when it is ready. For example, if your report contains a chart, the outline of the chart and the data below would appear. Then as the details of the chart become available the report is updated.

Report Engine improvements

The Report Engine has been improved to decrease wait time. In some cases, this results in a report opening and being ready to view up to 10 times faster than before.

Use of Thread Pooled Job Handling

The Web Component Server makes use of thread pooled job handling. Each time a request is made by a client, the Web Component Server passes the job to a worker thread that handles the request. By allocating a new thread for each task, the server can exploit the inherent power of multi-tasking in the operating system, delivering reports in the most efficient manner.


The Seagate Web Reporting solution

There are three products included with the Seagate Crystal Reports Professional and Developer edition that enable you to give users access to Seagate Crystal Reports over the Web.

  • Report Viewers
  • Web Component Server
  • Page Server.

This reporting solution has been designed for web sites using Microsoft, Netscape, and most CGI compliant web servers running in a Microsoft Windows NT environment.


Report request overview

The following diagram illustrates how the different components work in conjunction with your existing web server:


Report request steps

Step #1

Using a web browser, a user connects to your web server and makes a request. The web browser uses a Report Viewer to communicate with the server.

Step #2

If you are using a Microsoft or Netscape web server, the request is processed using ISAP or NSAPI. If you are using a Lotus Domino Server or another CGI compliant server, the request is processed using CGI. The request is then forwarded to the Web Component Server.

Step #3

After the Web Component Server has queued and determined the type of request, it is forwarded to the Page Server.

The only exception is the processing of an HTML request. The images in an HTML report do not follow the next two steps, they automatically go to step 4.

Step #3.1 and #3.2

The Page Server takes care of EPF generation and caching. When it is finished, the EPF details are forwarded to the Web Component Server.

Step #4

If this is an HTML request, the Web Component Server translates the report page to HTML. The Web Component Server then forwards the HTML and stores the .CRI files until they are requested.

Step #5

The web server forwards the report to the appropriate Report Viewer which displays the report in the user's browser.


Web browser/Report Viewers

The most common web browsers are Microsoft Internet Explorer and Netscape Navigator. The web browser uses a Report Viewer (ActiveX, Java, or HTML) to communicate with your existing web server.

For more information on Report Viewers, see Report Viewer overview.


Web server

Seagate Crystal Reports web components support Microsoft, Netscape, and most CGI compliant web servers running in a Microsoft Windows NT environment.


Web Component Server

When you install the Web Component Server, two new file extensions are established on your system: .rpt and .cri. When the web server receives a request for either of these file types, it directs the request to one of the Web Component Server connectors (wcsinsapi.dll or wcscgi.exe).

The wcsinsapi.dll works with ISAPI/NSAPI. These extensions are used with the Microsoft and Netscape web servers.

If you are not using either the Microsoft or Netscape web servers, the Web Component Server uses the wcscgi.exe file.


ISAPI/NSAPI

By utilizing the API extensions exposed by Microsoft and Netscape web servers, wcsinsapi.dll produces a faster, more robust system for report delivery to the web server.

The ISAPI extension works with Microsoft Internet Information Server (IIS) version 2.0 and later, as well as the Personal Web Server for Windows NT Workstations.

The NSAPI programming interface is available on all Netscape web servers.


CGI

If you are using the CGI standard the Web Component Server uses the wcscgi.exe file.


HTML Report Format

When a report is generated in HTML, graphic images, maps, charts, and OLE objects are rendered as Crystal Image (.CRI) files and are stored within the Web Component Server. When the Web Component Server encounters a Crystal Image inside of the HTML report, it translates the image into a form that can be displayed by browsers (such as JPEG format), and sends the image back to the web server for distribution.

Note: If you are using the Active X, Java, or Netscape Plug-in Report Viewer, the Encapsulated Page File (EPF) format is used instead of the Crystal Image file format.


Web Component Server vs. Active Server Pages

As an alternative to using the Web Component Server, you can use Active Server Pages. The method you use depends on whether you are a web administrator or a web developer.

If you are responsible for web development (writing scripts and applications to customize the functionality of your site), you may want to consider using the RDC Automation Server and Active Server Pages. The RDC Automation Server provides complete control over how reports are presented and delivered to a client. Powerful features such as changing the source of data used or manipulating existing report formulas are available at runtime. However, the RDC Automation Server requires extensive programming inside the Active Server Page environment. Familiarity with a scripting language such as VBScript or JScript is required.

Note: If you are not using a Microsoft or other ISAPI compliant web server, the RDC Automation Server and Active Server Pages are not available as a means of distributing reports from a web site.

In contrast, the Web Component Server takes less time to set up and does not require any programming or scripting. You simply store reports inside a directory accessible by your web server, then create standard HTML style links to the reports in your web pages. You are able to make some runtime changes to reports, such as record selection and the ability to change stored parameters. However, these options are limited in both scope and functionality.

For more information about using Active Server Pages, refer to the RDC Automation Server in the Technical Reference Guide.


Page Server

The Page Server runs on your Windows NT system as an NT service. It is primarily responsible for receiving .rpt report file requests from the Web Component Server and returning the pages to the Web Component Server.


Page Server format

When the Page Server generates a report, it translates the report into Encapsulated Page File (EPF) pages. EPF is a Seagate Software format based on the Encapsulated Postscript format (EPS). This page format is used by the Report Viewers for ActiveX and Java.

As a result, EPF reports can handle complex layout and design descriptions. When viewed inside the browser, EPF reports retain most, if not all of the design and layout elements of the report originally created in Seagate Crystal Reports. As it is a proprietary format, EPF reports can only be displayed inside the Report Viewers for ActiveX or Java.

Note: EPF files retain formatting information set by printer drivers. This includes settings like default page size and orientation.


Job sharing and page caching

This section provides a general description of how the Page Server caches and shares jobs.

When a client requests a report that has not been requested before, the following occurs:

  • A new job is created. When this happens a cache is created. The cache holds the report pages as they are requested. A reference to the report job is also created. The reference has a unique ID (Request ID) that is used to access the job if it is requested again in the future.
  • A refresh interval is associated with the report job. This is the time interval (Database Refresh setting in the Web Components Manager application) after which a new request for the same report results in accessing the database for updated information. In other words, if a new client requests the report after the refresh interval for the existing report job, then a new report job is created.
  • If a client referencing an existing report job selects refresh, then a new report job is created and the client receives a reference to the new job.
Job sharing

Job sharing occurs when more than one person accesses the same instance of a report. A report job can be shared if:

  • the report contains saved data and there are no selection formula (SF#) or group selection formula (GF#) commands
  • the report does not have saved data and there are no selection formula (SF#) or group selection formula (GF#) commands
  • the selection formula (SF#) or group selection formula (GF#) commands are identical to the formulae of an existing job.

The sharing of a report stops in the following situations:

  • A client sharing an existing report job clicks refresh. In this case, a new report job is created and the client receives a reference to the new report job.
  • A client sharing an existing report job submits a page request that includes one of the commands listed above. In this case, a new report job is created and the client receives a reference to the new report job.
Page caching

A cache, associated with each report job, stores requested pages. The pages are generated then passed to the client and stored in the cache. If another client who is sharing the same report job requests a page that is already cached, then that client receives the cached page. This can greatly reduce access time.


Improving performance

You can improve the performance of your Web Components Server and increase the number of people who are able to access reports over the Web by using some of the following suggestions.


Saving data with reports

Reports with saved data

A report that is saved with data and does not have selection or group selection formulas applied to it will have its pages shared by all users. If the report has the selection or group selection formulas applied, the caching will be by the user as in Seagate Crystal Reports 7.

Reports without saved data

A report without saved data that does not have selection formula (SF#), group selection formula (GF#), password prompt (PASSWORD#), user id prompt (USER#), parameter prompt (PROMPT#) or prompt for values on refresh (promptOnRefresh#) commands will have its pages shared by all users.

Because reports are not saved with data, the administrator must specify the database refresh time interval in the Web Component Manager application. This interval indicates how often the database will be accessed. Here is an example:

  1. The database refresh time is set to 5 minutes.
  2. User A selects report A1 (without saved data). Since User A is the first person to select this report, the database is accessed.
  3. Two minutes after User A requested Report A1, User B selects Report A1. User A and User B will share the report's pages because the report was requested before the database refresh time expired. As a result, the database is not accessed.
  4. Six minutes after User A requested Report A1, User C selects Report A1. Since the database refresh time interval has expired (the setting is 5 minutes and 6 minutes have passed since the database was accessed for this report), the database will be accessed and User C will not share the pages with User A or User B.


Drilling-down on data

A unique feature of the Web Component Server is the ability to perform drill-down analysis on report data to view the details hidden behind subtotals and summary values. Users can click or double-click summary values that allow drill-down to display the detail values on a separate page. A summary report comprising of only a few lines can be expanded to show all of the data used to derive the summaries.

As a web administrator, you can minimize hits on the database server by designing brief summary reports that enable selective drill-downs on GroupBy reports. Calculation of additional data is limited to specific user requests. For example, if a report contains 10 groups, and each group contains 10 detail values, a report designed to display all values immediately will require obtaining or generating 110 pieces of data (10 x 10 detail values plus the 10 summary values). However, if the report is designed as a drill-down report and only the summary values appear when the report is first generated, only 10 values need to be sent. If the client chooses to drill-down on two groups, 20 more values are retrieved from the database, for a total of 30 values. This difference, 30 versus 110, shows how network and database resources can be drastically reduced by designing a drill-down report for distribution.


Group Tree (using SQL GroupBy command)

If your reports contain server-side processing of SQL GroupBy statements, the Smart Navigation Group Tree will be affected when the reports are displayed. In these cases, only summary information is returned to the client. Detail records are evaluated by the SQL server and grouping and summary values are calculated and then sent to the client without the detail records.

Although this method greatly reduces the amount of data sent across the network, it also affects the Group Tree. Group names are listed in the Group Tree as they normally would be. However, if you expand a group in the Group Tree, the detail information will not be available. The server sends only the group summaries to the client. A magnifying glass will appear beneath the group name in the Group Tree indicating that detail data can be retrieved.

If the magnifying glass is clicked, the Web Component Server will retrieve the detail data for that group and display detail groups or record names beneath the original group name. This process requires querying the database. You may not want to use this feature if you think people viewing the report are always going to want to view the details of the summary.


Web Component Server Implementation

This section provides you with information to help you install and configure the Web Component Server.


Implementation overview

To implement a Web Component Server complete the following five processes:

  1. Install the Web Component Server.
  2. Configure NT Services.
  3. Ensure the installation is successful.
  4. Create a sample web site.
  5. Specify the Report Viewer.

Note: The Configure NT Services and the Specify the Report Viewer processes are optional.


Web Component connector

There are two types of Web Component connectors:

  • WCS CGI connector (uses CGI standard)
  • WCS via ISAPI\NSAPI (uses Microsoft and Netscape programming interfaces).

The Web Component connector used in your environment depends on the type of web server you are using.

Note: Another option is to install the RDC Automation Server inside Active Server Pages to distribute reports. This technique is substantially different from the Web Component Server.

For more information about using Active Server Pages, refer to the RDC Automation Server in the Seagate Crystal Reports Technical Reference Guide.


WCS CGI connector

The WCS CGI connector application (wcscgi.exe) is designed to support the CGI standard. Since most web servers support CGI, the Web Component Server can be installed on any CGI compliant web server.

The Lotus Domino web server uses the WCS CGI extension.


WCS via ISAPI\NSAPI

The ISAPI\NSAPI connector for the Web Component Server (wcsinsapi.dll) implements both ISAPI and NSAPI programming interfaces. These interfaces provide powerful direct connections to Microsoft (ISAPI) and Netscape (NSAPI) web servers.


System requirements

The Web Component Server supports the following operating systems:

  • Windows NT Server 4.0 or later with:
      • Microsoft Internet Information Server (IIS) 2.0 or later
      • Netscape Enterprise Server 2.0 or later.
  • Windows NT Workstation 4.0 or later with:
      • Microsoft Personal Web Server
      • Netscape FastTrack 2.0 or later.
  • Windows 2000 with Microsoft Personal Web Server
  • The Web Component Server supports the following web server applications:
      • Microsoft Internet Information Server (IIS) 2.0 or later
      • Microsoft Personal Web Server
      • Netscape Enterprise Server
      • Netscape FastTrack 2.0 or later.

The CGI version of the Web Component Server is compatible with all CGI compliant web servers.


Installing the Web Component Server

This procedure assumes that you have already installed a web server and have confirmed that it is running correctly. You must be logged as an administrator on the local machine.

Note: Before starting the installation, check to make sure that your web server is not running.


To install from the CD-ROM

Begin by inserting the Seagate Crystal Reports CD into your CD-ROM drive.

  1. The Seagate Crystal Reports Setup window appears with the Welcome information.

    Note: If the splash screen does not appear, run Setup.exe from the root directory of the CD.

  2. Read the Welcome information, then click Next. The License Agreement appears.
  3. Read the license agreement completely to understand the Seagate Crystal Reports licensing requirements. Select I accept the License Agreement if you agree with the terms in the license, then click Next. If you do not agree, you cannot install Seagate Crystal Reports.

  4. In the User Information window, enter your full name, organization, and CD Key Code to install the software, then click Next.
  5. Select Complete to install all components including Web Component Server (recommended) or Custom to specify individual components, then click Next.

    If you chose Complete, go to step 8.

    If you chose Custom, continue with step 6.

    Note: You may want to consider installing the entire Seagate Crystal Reports product on your web server system. With the entire product installed, problems with web reports can be quickly and easily analyzed by opening them inside the Report Designer directly on the web server system.

  6. Choose each of the following features and Will be installed on local hard drive:
      • Data Access
      • Developer Components
      • Export Support
      • Geographic Mapping
      • Sample Reports
      • Developer Samples/Web
      • Web Component Server.
  7. Click Next.
  8. Select a Program Group for your Seagate Crystal Reports program icons, then click Next.

    Setup begins installing the necessary files for the Web Component Server.

    After the files have been installed, the Web Component Server Configuration dialog box appears.

  9. If you make changes to the default configuration settings click Apply, then click OK.
  10. Setup completes the installation.

    After the installation is finished, a dialog box appears indicating that your machine needs to be restarted before the new settings take effect.

  11. Click OK, then restart your machine.


Installed files

The following is a list of primary files installed for the Web Component Server:

  • wcsinsapi.dll
  • wcscgi.exe
  • pagerserver.exe
  • wcs_xn_crimage.dll
  • webcompserver.exe
  • wcs_xn_reportviewer.dll.

Each of these files is installed by default into the following directory:

C:\Program Files\Seagate Software\WCS

Note: Refer to the Seagate Crystal Reports online Developer Help for a complete list of files installed with the Web Component Server.


Configuring Lotus Domino to work with the Web Component Server

If you are using a Lotus Domino server, complete the following procedure before accessing reports over the Web.

  1. Copy the wcscgi.exe file into the Lotus Domino cgi-bin directory.

    This gives Domino Webserver access to the Crystal Reports Web Server program files through its CGI directory.

  2. Create a virtual directory in Lotus Domino for Seagate Crystal Reports.

    Use the Domino Configuration database to do this. If you do not have a Domino Configuration database, create one called domcfg.nsf in the Domino Server default data directory using the Domino Configuration template (domcfg.ntf).

  3. Map the URLs to the report.

    The steps for doing this will vary depending on the version of Domino you are using. Refer to Domino's online help for more information.

      • Mapping Directories in Lotus Domino Version 4.x

    Using the Domino Configuration Database follow the path Create -> Mapping URL -> Directory and map the four directories below:

    URL Path Directory

    1

    /scrreports/*

    c:\Progra~1\Seagat~1\Crysta~1\Reports\*

    2

    /scrsamples/*

    c:\Progra~1\Seagat~1\Crysta~1\samples\ code\web\*

    3

    /viewer/*

    c:\Progra~1\Seagat~1\Viewers\*

    4

    /reports

    d:\notes\data\report

    The first two mappings are optional. They enable you to view samples that are included with the product.

    The third mapping is required; this is the directory where the viewer clients are stored. When a browser requests a report, the Web Component Server interprets the browser and automatically loads the proper viewer (Java, ActiveX, HTML, or HTML with Frames).

    The fourth mapping is required. This sets the current directory on the server whenever a request comes in for a report. The actual name of the directory (in this case /reports) is whatever you set up under the Notes data directory. It is activated via the URL redirection below.

    In Directory Mapping, you can specify the IP address to which the mapping applies. This is only necessary if you are running multiple Virtual Servers and wish to restrict reporting access to one of them. All of the Directory Mappings should also be set to Read access not Execute. It is recommended to enter something in the comment field for reference, but this is optional.

      • Mapping directories in Lotus Domino Version 5.X

    Open the Domino Administrator. Click the Configuration tab and open the server ->Current Server Documents view. Then select the Web.button. Create a URL Directory Mapping Redirection.

    URL Path Directory Access Site Information

    1

    /scrreports/*

    c:\Program Files\Seagate Software\Crystal Reports\Samples\Reports\*

    Read

    Optional

    2

    /scrsamples/*

    c:\Program Files\Seagate Software\Crystal Reports\Samples\*

    Read

    Optional

    3

    /viewer/*

    c:\Program Files\Seagate Software\Viewers\*

    Read

    Optional

    4

    /reports

    d:\notes\data\report

    Read

    Optional

    The first two mappings are optional. They enable you to view samples that are creatd with the product.

    The third mapping is required; this is the directory where the viewer clients are stored. When a browser requests a report, the Web Component Server interprets the browser and automatically loads the proper viewer (Java, ActiveX, HTML, or HTML with Frames).

    The fourth mapping is required. This sets the current directory on the server whenever a request comes in for a report. The actual name of the directory (in this case /reports) is whatever you set up under the Notes data directory. It is activated via the URL redirection below.

    In Directory Mapping, you can specify the IP address to which the mapping applies. This is only necessary if you are running multiple Virtual Servers and wish to restrict reporting access to one of them. All of the Directory Mappings should also be set to Read access not Execute. It is recommended to enter something in the comment field for reference, but this is optional.

  4. Restart the Lotus Domino server.
  5. Ensure NT Services have started.
      • Choose Services from the Control Panel.

        The Services dialog box appears.

      • Confirm the Seagate Page Server and Seagate Web Component Server services have started. If they are not running, click Start.

  6. Access sample reports by entering the URL into your web browser

    http:/localhost/scrsamples


Configuring NT Services

You may need to make changes to the Seagate Page Server services if:

  • the Page Server accesses secured reports or reports that are not on the local machine
  • the Page Server accesses reports that use data sources that cannot be accessed through the local system account
  • the web server does not have a local printer device.


Shared files and NTFS security considerations

If the Page Server uses the system account to access report files that are not on the local machine, or files which the system account does not have permissions to, you might receive an error. You can avoid this by changing the account to a domain user that can access network files and has sufficient permissions to access the report file.


Data source considerations

If the data source requires permissions that are greater than those of the local system account you will not be able to access the data file and you will receive looping logons. Two examples of this are outlined below:

  • If your reports are created using a PC database (Microsoft Access or Microsoft FoxPro) and you reference the data file with a UNC path, or ODBC DSN is referencing a UNC path, and the Page Server is running under the local system (or any other local account).
  • If your reports access the data through a database client like Informix Metacube or Arbor Essbase, and the Page Server is running under the local system (or any other local account).

To correct this, change the account the Page Server uses to a domain account that has access to the network share where the data is stored.


Printer considerations

The Seagate Page Server settings may need to be changed if the web server does not have a local printer installed and you are using the local system (or other local user) account.

Local accounts, including the local system account do not support the use of a network printer device and as a result the Report Engine uses a different mode to generate the Encapsulated Page Files (EPFs). The quality of these EPFs may not be as good as what they could be with a specified printer driver.

To configure NT Services

The steps below provide you with information about how to configure NT Services to use a user account that has a printer driver installed.

This procedure is made up of two processes:

  • creating a user
  • changing the services.


Creating a user

  1. While logged on as a Windows NT Administrator, open the User Manager for Domains application.

    If you are not familiar with this application, refer to Microsoft Windows NT documentation.

  2. On the User menu, click New User.

    The New User dialog box appears.

  3. Enter a new user name to be used by the Web Component Server. For example: CRWEBUSER.
  4. Provide a password that you will remember.
  5. Clear the User Must Change Password at Next Logon check box.
  6. Select the User Cannot Change Password check box.
  7. Select the Password Never Expires check box.
  8. Click Groups, and make this user a member of the Administrators group.

    .

  9. Click OK to close the New User dialog box.
  10. Close the User Manager application.


Changing the services

  1. Open the Services window.

    If you are not sure how to do this, refer to Microsoft Windows NT documentation.

  2. Select the Seagate Page Server from the Services list, then click Startup.
  3. Ensure Automatic is selected as the Startup Type.
  4. In the Log On As area, select This Account.
  5. Click the Browse button next to the This Account field, then locate the user you just created (CRWEBUSER).
  6. Click Add, then click OK.

    The Service dialog box appears.

  7. Enter the correct password for the user in the appropriate text boxes.

  8. Click OK to the Services confirmation dialog box.
  9. Close the Services window.


Ensuring successful installation

Once Setup finishes installing the Web Component Server, and you have restarted your system, your web server automatically restarts. If it does not restart, refer to the documentation for you web server software.

After confirming that the web server has restarted, verify that the Web Component Server is correctly installed.

To ensure successful installation
  1. From the Seagate Crystal Reports Programs Group, select Web Samples

    - or -

    Open a browser (such as Internet Explorer or Netscape Navigator), and enter the following URL address:

    http://localhost/scrsamples

    The Seagate Crystal Reports Web Samples & Utilities Page appears in the browser.

  2. From the Report Server Samples area, click view the samples.
  3. Select a Server Type:
      • WCS via ISAPI\NSAPI Extension
      • WCS CGI Extension
      • ASP Reports Server.
  4. Select a Report Viewer:
      • Report Viewer for ActiveX
      • Report Viewer for Java Viewer using Browser JVM
      • Report Viewer for Java Viewer using Java Plug-in
      • Report Viewer for Netscape Plug-in
      • Report Viewer for Standard HTML with Frames
      • Report Viewer for Standard HTML.
  5. Identify a report, then click view sample.

    The report appears in the appropriate viewer.

If you have trouble getting the Web Component Server running correctly on your web server, you may need to check the configuration of the web server itself.


Microsoft Internet Information Server 4.0

To determine whether the Web Component Server is configured correctly in Microsoft IIS version 4.0, follow these steps:

  1. Start the Internet Service Manager.
  2. Under Console Root, expand the Internet Information Server folder to expose the machine you are using as the server.
  3. Right-click on the machine icon and click Properties from the shortcut menu.

    The Properties dialog box appears with the Internet Information Server tab active.

  4. Select WWW from the Master Properties drop-down list.
  5. Click Edit.

    The Service Master Properties dialog box appears.

  6. Click the Home Directory tab.
  7. Click Configuration.

    The Application Configuration dialog box appears.

  8. Locate the extension .rpt and ensure that it points to the correct path for the wcsinsapi.dll.

    The default path is:

    C:\Program Files\Seagate Software\WCS\wcsinsapi.dll.

  9. Verify that the .cri extension also points to the same place.


Netscape Servers

To determine whether the Web Component Server is configured correctly on Netscape web servers, follow these steps:

  1. Locate the MIME.TYPES file and the OBJ.CONF file. These files are normally located in the following directories:
      • Netscape Enterprise 3.51:

        <dir>\Netscape\SuiteSpot\https-<machinename>\config

      • Netscape Enterprise 3.0:

        <dir>\Netscape\SuiteSpot\https-<machinename>\config

      • Netscape Enterprise 2.0 and Netscape FastTrack:

        <dir>\Netscape\server\https-<machinename>\config

  2. In MIME.TYPES, verify the following lines appear:

    type=magnus-internal/rpt exts=rpt

    type=magnus-internal/cri exts=cri

  3. In OBJ.CONF, verify that the following line appears:

    Init fn="load-modules" funcs="req_handler"

    shlib="C:/Program Files/Seagate Software/WCS/wcsinsapi.dll"

  4. In OBJ.CONF, under the heading <Object name="default"> verify that the following lines appear:

    NameTrans fn="pfx2dir" from="/viewer"
    dir="C:/Program Files/Seagate Software/Viewers"
    NameTrans fn="pfx2dir" from="/scrsamples"
    dir="C:/Program Files/Seagate Software/Crystal
    Reports/samples/code/web"
    NameTrans fn="pfx2dir" from="/scrreports"
    dir="C:/Program Files/Seagate Software/Crystal
    Reports/samples/reports"
    Service fn="req_handler" method="(GET|POST)"
    type="magnus-internal/rpt"
    Service fn="req_handler" method="(GET|POST)"
    type="magnus-internal/cri"

  5. If any of these lines are missing, add them to the appropriate file.
  6. Shut down the Netscape web server and reboot your web server system.


Virtual directories

As part of the installation process, the following virtual directories should be set up on your web server pointing to the indicated paths:

  • /scrreports
  • /scrsamples
  • /viewer.


Creating a web site

Once you have installed and set up the Web Component Server, the next step is to create a web page that contains report links.

To create a web site

First, you must decide on a location for your new web page, then create a virtual directory for the site that points to the new directory.

  1. Create a directory where you want to store your reports. Copy the reports into the directory.

    This example uses the World Sales Report and Account Statement reports and the directory:

    c:\webroot\newsite

    Note: For information on the location of your web server's root directory, refer to your web server software documentation. The directory shown here is intended only as an example.

  2. Use your web server administration software to create a virtual directory to point to the physical directory you have just created. You will probably need to give this virtual directory "execute" permission. For this example, we will use the virtual directory:

    mydirectory

  3. Using a simple text editor, such as Notepad, or your favorite HTML editor, create a page with links to the reports in the virtual directory. For this example use the following HTML code:

    <HTML>
    <HEAD>
    <TITLE>Index of Reports</TITLE>
    </HEAD>
    <BODY>
    <H1>Check out these reports!</H1>
    <HR>
    <UL>
    <LI><A HREF="http://localhost/mydirectory/account statement.rpt">
    Account Statement
    </A></LI>
    <LI><A HREF="http://localhost/mydirectory/world sales report.rpt">
    World Sales Report
    </A></LI>
    </UL>
    </BODY>
    </HTML>

  4. Save the file as reportlist.htm in the c:\webroot\newsite directory.
  5. Open your web browser, and enter the following URL:

    http://localhost/newsite/reportlist.htm

  6. Click one of the two links in your new web page to generate and display the report inside your browser.

In this example, you specified two .rpt files using standard URL addresses. The .rpt extension is analyzed by your web server, and is determined to be an extension that should be handled by the Web Component Server application. The URL is handed off, and the Web Component Server determines how to handle the requested .rpt.

When the report is displayed inside your browser, the Web Component Server analyzes the type of browser you are using and delivers the report using a Report Viewer it determines is appropriate. For example, if you are using Internet Explorer 4.0, you will see the report inside the Report Viewer for ActiveX. If you are using Netscape Navigator 4.0, you will see the report inside the Report Viewer for Java.


Specifying the Report Viewer

As a web site designer, you can specify which viewer is used when the report is requested, overriding the default viewer used according to the browser. For example, the following URL forces the Java viewer to be used, even if you are running Internet Explorer or any other web browser:

http://localhost/mydirectory/account statement.rpt?init=java

Note: If the user's browser does not support the technology used by the viewer specified, Java in this case, an error will occur or an empty web page will be displayed.

In this URL, INIT is a parameter recognized by the Web Component Server. By setting the INIT parameter equal to Java, you can force the Web Component Server to use the Report Viewer for Java when displaying the report inside a browser. The Web Component Server supports several parameters for controlling how reports are generated and displayed. For more information, see Web Component Server Commands.


Web Component Server Administration

This section provides you with information about how to configure the Web Component Server using the application provided.


Administration overview

The Web Components Manager application gives you control over how reports are delivered and accessed from your web site. This section contains information about the settings that can be changed in each of the four tabs that make up the Crystal Report Web Components Manager application.


Accessing the Crystal Report Web Components Manager

To access the Crystal Report Web Components Manager
  1. Locate the wcmadmin.exe file.
  2. Double-click cmadmin.exe to launch the application.

    The Crystal Report Web Components Manager application appears. It has four tabs:

      • Web Component Server
      • Cache Settings
      • Report Viewing
      • Page Server.


Web Component Server tab

This tab is made up of the HTML Images, Viewer Virtual Path, and Server Port areas.


HTML Images

The Temporary Image File Location field specifies where the .CRI images returned with the Report Viewer for HTML are stored.


Viewer Virtual Path

This field specifies the virtual path to use for all report viewers and images returned by the Web Component Server.


Server Port

The Server Port area contains the port number that the Web Component Server uses to listen for requests from a Web Component Server connector.

Note: If you make changes to the Server Port information stop and restart the NT Services for the web server and Web Component Server. For all other changes stop and restart the NT Services for the Web Component Server.


Cache Settings tab

The Cache Settings tab is made up of the Cache Directory and Cache Maintenance areas.


Cache Directory

This field specifies where cached reports are stored on the server system. If you accept the default directory settings during installation, they are saved to:

C:\Program Files\Seagate Software\WCS\Cache\Temp


Cache Maintenance

In the Cache Maintenance area, you can specify the Maximum Cache Size in KBytes and the Minutes between cache file cleanup.

Maximum Cache Size in KBytes

This is the maximum space, in kilobytes, that can be used on the Page Server system drive to cache report pages. If report requests begin to exceed this drive space, older pages are deleted (based on a LRU algorithm) from the cache until there is room for newer pages.

Note: To apply your changes stop and restart the NT Services for the Page Server.


Report Viewing tab

Use the Report Viewing tab to control what options are available to users when they view a report inside a browser. This tab is made up of three areas:

  • All viewers
  • ActiveX and Java
  • HTML Page.

Also included in this tab is the Java Plug-in button.

Note: The following doesn't apply to Report Viewers that are accessed via an Applet or Object tag in an HTML page. In these cases, viewer options are set via parameter tags in the page.

Select and clear the check boxes to turn the options on and off.


All viewers

This area contains check boxes that enable you to give users access to:

  • Search Report
  • Drilldown within Report
  • Generate GroupTree
  • Refresh Report.


ActiveX and Java

This area contains check boxes that enable you to give users access to the following functions:

  • Print Report
  • Display logo
  • Zooming control
  • Display GroupTree
  • Allow export.

Select or clear the Display GroupTree check box to control whether or not a Group Tree is generated for Smart Navigation inside Report Viewers.

Note: Generating a group tree for a report requires the Web Component Server to make an additional pass through the report data to create the Group Tree. This can cause response delays and requires additional system resources, especially if the report contains a large number of groups or multiple groups within groups.


HTML Page

This area contains a check box that enables users to see the Navigation toolbar.


Java Plug-in

Click this button to change the location, version, and MIME Type of the Java Plug-in you are using. This is useful if you would like to use a new version of the Java VM Plug-in.

Note: To apply your changes stop and restart the NT Services for the Web Component Server.


Page Server tab

The Page Server tab is made up of four areas: Processing, Database Refresh, Idle Time, and Server Port.


Processing

This area enables you to make changes to the maximum number of threads.

Maximum number of threads

The Page Server is a multi-threaded application. For each request it receives, it generates a new thread for processing.

Threads consume system memory and resources. A large number of threads can slow down the overall performance of a system.

By specifying the maximum number of threads that can be generated by the Page Server, you are able to control the amount of system resources that can be dedicated to responding to requests at any given time. If the number of requests received by the Page Server exceeds the number of threads specified, additional requests are held until threads are available.

When determining a maximum number of threads, you should consider the available memory on the server system and the size of the reports that are commonly accessed. Large reports require more time and additional system resources.


Database Refresh

This setting controls how often the data in cached reports is refreshed by querying the database.

If the Database Refresh Time has passed since the report was first cached, the Page Server can refresh the data in the cached report the next time a user requests it.

By controlling how often the data in reports is refreshed, you can minimize the impact of client requests on the database. Clients who are allowed to refresh the data themselves may put a large load on the database server. Instead, as the administrator, you can control how often data is refreshed.

Keep in mind that the Report Viewers include a Refresh button by default. If you set a database refresh time, and a client uses the Refresh button in a Report Viewer, the user causes a refresh on the cached report, forcing a request to the database. You may want to turn off the Refresh button. For more information, see Report Viewing tab. If you set the Database Refresh Time to 0, the data is refreshed each time a report is requested.

Also included in this area is a check box that enables you to decide whether or not the database is hit when the user clicks refresh from their web browser.


Idle Time

Idle time is a period of time during which no action occurs.

Minutes before idle job is closed

A job refers to a report that has been generated and cached on the server. If nobody requests the report for the time specified, the report job is closed and discarded. As a result, if someone requests the report after the job has been closed, a new job needs to be generated, causing an initial delay.


Server Port

This indicates the port that the Page Server listens for requests from.

Note: If you make changes to the Server Port information stop and restart the NT Services for the Web Component Server and Page Server. For all other changes stop and restart the NT Services for the Page Server.


Web Component Server Commands

This section provides examples of Web Component Server commands that can be appended to URL requests. These URL requests can be used to prompt users to enter security information or parameter field values.


Commands overview

Pre-defined reports created with Seagate Crystal Reports are instantly available to any user connected to your web site via the Internet or an intranet. As a web server administrator, you are able to determine how data is accessed from your web site and exactly how much of the data is available. The Web Component Server provides several commands that can be appended to URL requests. In addition, the Web Component Server provides the option of automatically prompting users for security information, stored procedure parameters, and parameter field values.

Note: The features described here allow you to control access to report information on a limited basis. Although the commands described in this section provide a certain level of customization, you should consider using the RDC Automation Server to design web sites if you need more control over report data and formatting at runtime. Information about this method can be found in the Seagate Crystal Reports Technical Reference Guide.


Constructing report requests

When requesting a report from the Web Component Server, or when setting up a link to a report from another web page, there are several optional commands available for customizing the information returned.

Commands are passed with a report request by appending the URL address of the report with a question mark followed by each query string command you want to use.

Note: Commands can be passed in any order and in any combination. All commands are optional. If you do not specify any commands, the default viewer displays the report.

The following is an example of using query string commands when requesting a report:

http://<localhost>/scrreports/Accounting/ wsale.rpt?sf={customer.Sales}>10000

Note that each command is specified using the following syntax:

command=value

Where command is the first name of the command, and value is the value you assign to that command.

Note: The command is preceded by a question mark ? and additional commands are separated by an ampersand &.

It may be more convenient to embed the request in an HTML page and pass it to the Web Component Server via a FORM tag, as in the following example:

<FORM ACTION='http://localhost/scrreports/Accounting/
wsale.rpt?sf={customer.Sales}>1000' METHOD='post'>
<input type=submit value='Click Here To Launch the report: http://
localhost/scrreports/Accounting/ wsale.rpt?sf={customer.Sales}>1000'>
<input type=hidden name="init" value="html_page">
<input type=hidden name="promptOnRefresh" value="0">
</FORM>

The resulting URL and attached query string look like this:

http://localhost/scrreports/Accounting/wsale.rpt?sf={customer.Sales}>1000&init=html_page&promptOnRefresh=0


INIT command

Specifies the Report Viewer. For example:

init=java

Possible values are:

  • java - Report Viewer for Java
  • actx - Report Viewer for ActiveX
  • html_frame - Report Viewer for Standard HTML with Frames
  • html_page - Report Viewer for Standard HTML
  • nav_plugin - Report Viewer for Netscape Plug-in
  • java_plugin - Report Viewer for Java Plug-in.

If the INIT command is not specified, the Web Component Server detects the type of browser requesting a report and provides a default viewer for that browser. For instance, if the browser is Netscape Navigator 4.0, the Web Component Server displays the report using the Report Viewer for Java.

Note: Not all browsers support all methods of viewing reports.


Considerations

  • ActiveX and Java viewers are unavailable in Internet Explorer versions 3.02 and earlier
  • Authenticode 2.0 must be installed if you are using Internet Explorer
  • Netscape Navigator does not support the Report Viewer for ActiveX
  • Netscape Navigator version 3.0 and earlier does not support the Report Viewers for Java.


Changing Selection Formulas in Web Reports

In addition to specifying a record or group selection formula when designing a report, you can also change the selection formula using a command appended to the URL of a report called through the Web Component Server. As an administrator, you can create one report and design a web page that allows users to choose selection criteria for the information they need. The Web Component Server then dynamically generates the requested report with only the selected records.

To specify a record selection in a request for a web report, use the parameter SF command. For example:

http://server_name/reports/boxoffic.rpt? sf={studio.Studio}+%3d+'Universal'

This overrides any selection formula already contained in Boxoffic.Rpt. However, the new selection formula is not saved with the original report file. It is only valid for the currently requested job. The GF command (group selection) can be used to change a group selection formula in a report.

The Web Component Server does not check the validity of any selection formulas you send to a report. If the selection formula you create is invalid, an error is returned to the web browser. If you are designing a web site that passes selection formulas to reports, be sure to test the selection formulas before allowing users to access your site.


GF command (Group Selection)

Specifies a group selection formula. This command is similar to the selection formulas command.

GF=<formula>
«<formula> is a selection formula in string format.»

For example:

GF= Sum({customer.Sales},{customer.Region})>10000
«Selects all groups in which the sum of all customer
sales in each region is greater than 10,000.»


SF command (Selection)

Specifies a selection formula.

SF=<formula>
«<formula> is a selection formula in string format.»

For example:

http://server_name/reports/
boxoffic.rpt?sf={studio.Studio}+%3d+"Universal"
«Selects all records where the studio is Universal.»

Note: Reports that have exactly the same SF and GF commands applied and do not require logon information will share pages.


SQL and ODBC data sources

The Web Component Server opens reports based on SQL servers and ODBC data sources as easily as it opens reports based on smaller desktop database files. If the data in a report requires access to a secure data source such as a SQL server or ODBC data source, the Web Component Server automatically prompts the user requesting the report to provide a user ID and password before it displays report data.

Note: Although the Web Component Server requires users to log on before it displays reports that access secured databases, security conflicts can arise if several people attempt to access the same report simultaneously. To prevent this type of conflict, add security to your web site, preventing users from seeing and accessing secured reports. Forcing users to log on to the intranet site is a common solution to providing complete system security.

Depending on the type of data your reports are based on, the logon page that appears may differ slightly.

Note: If the database security has no password or a blank password, users are not be prompted by the Web Component Server to log on. To ensure security, make sure databases have valid passwords.

To create hyperlinks in your web pages that handle user IDs and passwords automatically, use the User and Password commands. These commands let you specify more than one user ID and password if the report connects to two or more secured databases. Keep in mind that if an incorrect user ID or password is sent, the Web Component Server prevents access until the correct information is supplied.

Note: The Web Component Server applies a simple encryption algorithm to user names and passwords. If you are using a Microsoft web server, make sure your intranet or extranet site has the Secure Sockets Layer (SSL) encryption protocol installed and enabled to ensure complete security when accessing database information. Due to a documented problem in the Netscape web servers, SSL is not supported by the Web Component Server on Netscape servers. For more information, refer to Netscape documentation.


PASSWORD# command

Specifies passwords for logging on to SQL, ODBC, or password-protected databases used by the report.

PASSWORD#=<password>
«<password> is a string.»

For example:

password0=secret

If the report accesses more than one password-protected database, multiple passwords can be passed by incrementing the index number. For example:

password0=secret&password1=mystery&password2=unknown

PASSWORD# is normally used in conjunction with the USER# command. For example:

user0=SmithJ&password0=secret&user1=JohnS&password1=mystery

If the report contains subreports that require passwords for logging on to SQL or ODBC data sources, use the following syntax in the URL:

password@subname#=<userid>
«subname is the name of the subreport.»

For example:

user0@Crosstab=jimmys&password0@Crosstab=jimmyz

Note: Make sure passwords appear in the URL in the same order in which the password-protected databases appear in the report. Additionally, if passwords are not passed using the URL address, the user is prompted for logon information at runtime.


USER# command

Specifies user IDs for logging on to SQL or ODBC databases used by the report.

USER#=<userids>
«<userids> is a string.»

For example:

user0=SmithJ

If the report accesses more than one password-protected database, multiple user IDs can be passed by incrementing the USER index number. For example:

user0=SmithJ&user1=JohnS&user2=JSmith

USER# is normally used in conjunction with the PASSWORD# command. For example:

user0=SmithJ&password0=secret&user1=JohnS&password1=mystery

If the report contains subreports that require user IDs for logging on to SQL or ODBC data sources, use the following syntax in the URL:

user#@subreportname

For example:

user0@Crosstab=jimmys&password0@Crosstab=jimmyz

Note: If an existing report is inserted as the subreport, then the subreport name includes the file extension (for example, user0@subreportname.rpt). However, if the subreport was created inside the main report (with Insert Subreport and using the Report Expert to create the new report) then the name of the subreport usually does not contain a file extension (for example, user0@subreportname) unless one is added in the "Report Name" text box of the Insert Subreport dialog box.

Note: Make sure user IDs appear in the URL in the same order in which the password-protected databases appear in the report. Additionally, subreport user IDs must appear in the same order that the subreports appear in the report. If user IDs are not passed using the URL address, the user is prompted for logon information at runtime.

Note: Reports are not be shared if there are logon requirements.


Alternate method

In addition to the syntax examples provided above, this release of Seagate Crystal Reports enables you to use an alternate method to prompt users for user and password information.

User

User-<servername>.<databasename>@<subreportname>

Password

Password-<servername>.<databasename>@<subreportname>


SQL stored procedures and parameter fields

Seagate Crystal Reports supports designing reports based on stored procedures in SQL databases. Additionally, the Report Designer allows you to create parameter fields in the report itself. Both stored procedures and parameter fields can prompt users at runtime for a value to base the report on. For example, a salesperson may want to only see sales information for their region. When they request the report, the report can prompt the salesperson to enter a region name. The report then delivers data just for that region.

To prevent users from specifying their own values for parameter fields or stored procedures, use the PROMPT# command when specifying the URL of a report. PROMPT# lets you specify values for one or more parameter fields in a report. Alternately, you can design your own web-based forms that accept user input and dynamically create the URL that includes the PROMPT# parameter and value.

Note: Users should not surround parameter values with quotation marks. All values are sent to the report as strings, regardless of the type of data. Parameters that expect numeric values interpret the string received when necessary.

The Web Component Server does not validate any parameter values you specify for stored procedures or parameter fields. If the value you pass to the parameter is invalid, passing text information when a number is expected, for example, an error is not returned to the web browser. In addition, the Web Component Server does not allow you to change the format expected by parameters. Be sure to test any web site that accesses reports with stored procedures or parameter fields before allowing users to request such reports.

Note: Parameter fields and SQL stored procedures limit the effectiveness of report caching and job sharing. Since each report containing stored procedures or parameter fields may generate a different set of data every time it is requested, multiple requests for the same report may not be distributable among multiple users.


Prompt# command

Specifies values for parameter fields in the report. Parameter values are assigned to parameters in the order in which they exist in the report.

PROMPT#=<value>
«<value> is a string.»

For example:

prompt0=CA

Note: Do not use quotation marks around parameter values to indicate string values. All parameter values are passed to the report as strings. Intended numeric values are translated from strings to numbers by the report.

If the report contains more than one parameter field, multiple values can be passed to parameters by incrementing the PROMPT index value. For example:

prompt0=CA&prompt1=1000

Note: Make sure parameter values appear in the URL in the same order in which the parameter fields and stored procedures appear in the report. If parameter values are not passed using the URL address, the user requesting the report is prompted to provide values at runtime.

Note: Reports that have the PROMPT# command applied do not have their pages shared. Caching will be by user.


PromptOnRefresh# command

Specifies whether report should prompt for parameter field values when refreshed.

promptOnRefresh#=<value>
«<value> is 0 or 1.»

For example:

promptOnRefresh=1

Note: Reports that have the promptOnRefresh# command applied do not have their pages shared. Caching will be by user.


Report exporting

The report server can export requested reports to the following formats:

  • HTML 3.2
  • HTML 4.0
  • Seagate Crystal Reports (RPT)
  • Excel 5.0 (XLS)
  • Excel 5.0 (XLS) Extended
  • Rich Text Format (RTF)
  • Word Document (DOC).

The report server assigns the CONTENT-TYPE header the appropriate MIME-TYPE, therefore, the browser can be configured to launch the appropriate application after downloading the file. To issue a request to the report server to export a report, the query string must contain two commands. These commands are CMD and EXPORT_FMT. The CMD command must always be assigned the value EXPORT, and the EXPORT_FMT command is assigned the desired Export Format. The table below lists the supported export formats and their corresponding EXPORT_FMT representation.


CMD# and EXPORT_FMT commands

Specifies that the report should be exported to the indicated format.

cmd=EXPORT&EXPORT_FMT=<EXPORT_FMT representation>

<EXPORT_FMT representation > is one of the following:

For example:

Export Format | Export_FMT Representation
HTML 3.2 | U2FHTML:2
HTML 4.0 | U2FHTML:3
Seagate Crystal Reports (RPT) | U2FCR:0
Excel 5.0 (XLS) | U2FXLS:3
Excel 5.0 (XLS) Extended | U2FXLS:4
Rich Text Format (RTF) | U2FRTF:0
Word Document (DOC) | U2FWORDW:0

If a user would like the report test.rpt downloaded to their browser in Microsoft Word format the URL (ISO - Latin encoded) would be:

http://mycomputer/test.rpt?cmd=EXPORT&EXPORT_FMT=U2FWORDW%3A0


Refreshing web report data

When a report contains saved data, the report does not need to access a database. It retrieves the information directly from the Web Component Server. This can greatly reduce network traffic and the use of network server resources when many people are frequently requesting reports. For this reason, you may want to design most of your reports so that they contain saved data. Additionally, reports containing saved data can be easily cached by the Web Component Server for optimized job sharing, serving more users with the same information simultaneously. However, if a report contains saved data, and changes are made in the original database, the report will not reflect accurate information. To update the report, you can open it in Seagate Crystal Reports, refresh the data, and save the report again. However, the Web Component Server also provides a means to dynamically refresh report data.

As a web system administrator, you must decide if you want to allow users to refresh report data themselves, or if you want to control how and how often they can refresh report data. Each of the Report Viewers include a button to refresh the data while it is viewed. However, sites with several users refreshing report data can result in network and system slow downs since every refresh requires connecting to a database and gathering data.

You can override or even disable the user's capability for refreshing and create other means for keeping up-to-date data in reports. One method is to set automatic refreshes using the Database Refresh setting in the Page Server tab of the Crystal Report Web Components Manager application. For more information, see Database Refresh.

When deciding how data will be refreshed at your web site, keep in mind that frequent refreshes of report data limits report caching capabilities of the Web Component Server. Every time the report is refreshed, any cached version of that report becomes obsolete.


Report Viewers

This section provides you with information about how to configure Report Viewers to effectively meet the needs of your users.


Report Viewer overview

When end users access a report on the Web Component Server, they launch a Report Viewer that works within their browser.

Seagate Crystal Reports includes six different Report Viewers:

  • Report Viewer for ActiveX
  • Report Viewer for Java using the Browser JVM
  • Report Viewer for Java using the Java Plug-in
  • Report Viewer for Netscape Plug-in
  • Report Viewer for Standard HTML with Frames
  • Report Viewer for Standard HTML.

You can choose to have the Web Component Server determine the Report Viewer that best suits the end user's web browser, or you can specify it by using Microsoft Visual InterDev and the Time ActiveX Control, and select the viewer using the Report Integration Controls. The appropriate code is added to your site automatically.


Report Viewer features

Seagate Crystal Reports provides rich and powerful reporting features for data analysis and presentation. Ideally, when a user accesses a report over the the Web the report retains these features. Several of the Report Viewers are designed to provide this power as it exists in the original report.

Web administrators often have important reasons for choosing one web technology over another when presenting information on a web site. When deciding on the Report Viewer technology used on your web site, you should consider the reporting features provided by each Report Viewer and be aware of any limits that a particular web technology might impose on the Report Viewers.

The following table illustrates the major reporting features available in each of the Report Viewers:

Features | ActiveX | Java | Java Bean | Netscape Plug-in | HTML Frames | HTML Page
View Graphs | Yes | Yes | Yes | Yes | Yes | Yes
View embedded maps | Yes | Yes | Yes | Yes | Yes | Yes
Smart Navigation Tree | Yes | Yes | Yes | Yes | Yes |
Drill down on graphs & summarized data | Yes | Yes | Yes | Yes |  |
Export to Word, Excel, HTML, RPT | Yes | Yes | Yes | Yes |  |
Change Record Selection Expert | Yes | Yes | Yes |  |  |
Search for specific data value | Yes | Yes | Yes | Yes | Yes | Yes
View subreports | Yes | Yes | Yes | Yes | Yes | Yes
Drill down on subreports | Yes | Yes | Yes | Yes |  |


Report Viewer defaults

The following table lists the Report Viewer that defaults when a user's web browser connects to the Web Component Server:

User's Browser | Default Viewer | Optional Viewers
Internet Explorer 3.02, 4.x, 5.x | ActiveX | Java, HTML Frame, HTML Page
Netscape Navigator 3.x | HTML |
Netscape Navigator 4.x (32 bit) | Java | Plug-in, HTML Frame, HTML Page
Other Browsers | HTML Page |

Although changing these defaults is not necessary, there may be times when you need to manually write web pages that display a specific viewer despite the browser being used, or when you want to customize your web site by editing the code created by the report integration controls.

If you develop sites using the RDC Automation Server, or if you connect to the Web Component Server from Active Server Pages or Visual Basic, you have several options for configuring the Report Viewers.

For more information about using Active Server Pages, refer to the RDC Automation Server in the Seagate Crystal Reports Technical Reference Guide.


Printing from Report Viewers

When you create a report in Seagate Crystal Reports, the program analyzes the printer that is currently selected for your system to determine font size and how to size and position objects, such as field objects and text objects on the report. If the report is then printed to a printer other than the one selected when it was created, problems with font size, clipped text, and pagination may arise.

With this in mind, consider what may happen when a report is created on one machine, served over the network by a web server on a second machine, and viewed or printed from a web browser through a Report Viewer on a third machine. If each of these machines is connected to a different printer, report formatting problems may be compounded.

Consider a report that is designed and formatted on the first machine, where printer settings are used to determine font size and the size and position of objects in the report. When the web server generates that report, the printer it is connected to may force the length and size of a font to change. However, the field and text objects maintain a fixed size and position. Thus, generating the report on the web server may cause text to be clipped or may create extra blank spaces between fields.

If, however, some report objects are formatted with the Can Grow formatting option, these objects resize themselves as the size of the text font is resized by the new printer. Once resized, though, these objects may change the pagination.

The Report Viewer for Java and the Report Viewer for HTML display the report in a web browser as it is generated by the web server, so these formatting problems may affect how reports appear to users. The Report Viewer for Java allows users who are using IE 4.0 and Netscape 4.06 or higher to print reports. The Report Viewer for HTML simply prints the HTML page exactly as it appears in your web browser. In contrast, the Report Viewer for ActiveX allows you to print a formatted report from a web browser. As a result, an additional level of formatting problems may appear in the printed report if the machine on which the web browser is running is connected to a third printer with different settings.

When designing reports that are viewed through one of the Report Viewers, use report fonts common on all systems to prevent resizing and pagination problems, and always test reports on a client machine before distributing them to users.


Using Report Viewers in applications

Viewing reports is not exclusive to web sites, you may find a need for client side applications that display reports on-screen to users. The Report Viewer for ActiveX and the Report Viewer for Java are fully functional components. These components can be added to applications written in Microsoft Visual Basic, Borland Delphi, Symantec Visual Cafe, and many other development environments that support ActiveX controls or Java Beans.

Note: The Report Viewer for Java is intended primarily for application development and is, therefore, not discussed in this chapter. Instead, this section concentrates on the Report Viewers intended for web site development that can be distributed using the Web Component Server or added using the Report Integration Controls.

Report Viewers are frequently used in application development when designing N-tier applications that use the Web Component Server and the RDC Automation Server as a middle tier, and the Report Viewer as part of the client user interface. For more information on using the ActiveX and Java Bean versions of the Report Viewers in application design refer to the Seagate Crystal Reports Technical Reference Guide.


Report Viewer for ActiveX

The Report Viewer for ActiveX is an ActiveX control that can be placed inside an HTML page and viewed through any browser that supports ActiveX. Microsoft Internet Explorer version 3.02 and later displays reports with the Report Viewer for ActiveX by default.

The Report Viewer for ActiveX can also be used inside any development environment that supports ActiveX controls. For more information on using the ActiveX viewer when developing applications, refer to the Seagate Crystal Reports Technical Reference Guide.

Note: The Report Viewer for ActiveX supports all types of objects (field, text, graphic, OLE, Cross-Tab, Subreport, map, line, box).


AuthentiCode certification

The Report Viewer for ActiveX is certified by Microsoft AuthentiCode 2.0. This certification requires Microsoft Internet Explorer 3.02 or later in order to open the ActiveX control. If you do not have a recent version of Internet Explorer, refer to the Microsoft web site to upgrade or use a different Report Viewer when designing your web sites.


Adding the Report Viewer to a web page

Microsoft's Internet Explorer web browser supports the OBJECT tag in HTML. This tag can be used to add the Report Viewer for ActiveX to a web page. Use code similar to the following:

<OBJECT ID="CRViewer" WIDTH=100% HEIGHT=95%
    CLASSID="CLSID:C4847596-972C-11D0-9567-00A0C9273C2A">
</OBJECT>

When you install the Web Component Server, the Report Viewer for ActiveX is installed under:

\Program Files\Seagate Software\Viewers\ActiveXViewer

Additionally, a virtual directory named:

/viewer

is set up on your web server, which points to:

\Program Files\Seagate Software\Viewers


Downloading the Report Viewer from the server

In order for a web browser to use an ActiveX control stored on the web server, the browser must be able to download the control from the server and register it locally. The CODEBASE attribute of the OBJECT tag allows you to specify the location of the original ActiveX control, relative to the current page. For example:

<OBJECT ID="CRViewer" WIDTH=100% HEIGHT=95%
CLASSID="CLSID:C4847596-972C-11D0-9567-00A0C9273C2A"
CODEBASE="/viewer/ActiveXViewer/CRViewer.dll#Version=1.0.0.0>
</OBJECT>

The first part of the CODEBASE attribute value indicates the location and file name of the ActiveX control as a URL address relative to the current web page. The Version attribute that appears after the # symbol is optional and allows you to specify which version of the Report Viewer for ActiveX you want to provide for your users. If you specify 1.0.0.0, the most recent version available on either the server or the client is automatically used by the browser.

When a web browser opens this page, it first checks the CLASSID attribute to see if the control is already registered on the client system. If not, or if the version number of the viewer is lower than the current viewer registered on the system, the browser uses the CODEBASE attribute to find the control and download it. Once downloaded, the control can be registered and displayed by the browser.


Parameters

The Report Viewer for ActiveX provides several optional parameters to customize the look of the viewer and to control its functionality. Apply values to these parameters by using the standard PARAM tag in your HTML code.

DisplayGroupTree

Indicates whether the Group Tree is displayed when the viewer first appears. If the Has Group Tree parameter is set to false, this parameter is ignored. If the Group Tree is hidden, the user can display it by clicking the Toggle Group Tree button in the viewer.

  • A value of 1 (TRUE) displays the Group Tree.
  • A value of 0 (FALSE) hides the Group Tree.
EnableAnimationControl

Indicates whether the viewer displays the Animation Control. The Animation Control runs while a report is being generated and downloaded. Once the report completely arrives at the client web browser, the animation stops.

  • A value of 1 (TRUE) displays the Animation Control.
  • A value of 0 (FALSE) prevents the Animation Control from being displayed.
EnableDrillDown

Indicates whether a user can drill-down on summary values in a drill-down report. In a drill-down report that appears in the Report Viewer for ActiveX, the mouse pointer becomes a magnifying glass over any group or value that can be drilled down on. Double-click the group or value to display a separate Drill-Down tab inside the viewer.

  • A value of 1 (TRUE) indicates the user can drill-down on reports.
  • A value of 0 (FALSE) indicates the user is not allowed to drill-down on reports.
EnableExportButton

Indicates whether or not the Export button appears in the Report Viewer. If the Export button appears, the user can export the displayed report to Microsoft Word, Microsoft Excel, HTML 3.2, or Seagate Crystal Reports format.

  • A value of 1 (TRUE) displays the Export button.
  • A value of 0 (FALSE) prevents the Export button from being displayed.
EnableGroupTree

Indicates whether the viewer generates a Group Tree for the report. Does not indicate whether or not the Group Tree is displayed. If HasGroupTree is set to 0, ShowGroupTree is automatically set to 0.

  • A value of 1 (TRUE) generates a Group Tree.
  • A value of 0 (FALSE) prevents a Group Tree from being generated.
EnablePrintButton

Indicates whether the user can print the report to a printer. When the user clicks the Print button, the report is sent to a printer according to the settings selected by the Standard Print dialog box. If the Has Print Button is set to 0, then you cannot print. For more information, see Printing from Report Viewers.

  • A value of 1 (TRUE) displays the Print button.
  • A value of 0 (FALSE) prevents the Print button from being displayed.
EnableRefreshButton

Indicates whether a Refresh button is available in the viewer to allow the user to refresh report data.

  • A value of 1 (TRUE) allows users to refresh report data.
  • A value of 0 (FALSE) prevents users from refreshing report data.
EnableSearchControl

The Search control and button that appear in the Report Viewer for ActiveX allow a user to easily search for and jump to instances of a specific value or field that appear in the report. The user enters the value of interest in the drop-down list, then clicks the Search button to find the first instance of that value. Clicking the button again finds successive instances of the value in the report.

  • A value of 1 (TRUE) displays the Search controls.
  • A value of 0 (FALSE) prevents the Search controls from being displayed.
EnableZoomControl

Use the Zoom Control to switch between levels of magnification in the Report Viewer for ActiveX. With the Zoom Control, you can magnify the report up to 400% of its original size, or reduce it down to 25% in order to see more of the report at once.

  • A value of 1 (TRUE) displays the Zoom Control.
  • A value of 0 (FALSE) prevents the Zoom Control from being displayed.


Embedding the Report Viewer for Active X in a web page

The following HTML code demonstrates one means of embedding the Report Viewer for ActiveX in a web page using the OBJECT tag:

<OBJECT ID="CRViewer"
    CLASSID="CLSID:C4847596-972C-11D0-9567-00A0C9273C2A"
    WIDTH=100% HEIGHT=95%
    CODEBASE="/viewer/activeXViewer/
activexviewer.cab#Version=1.0.0.0">
<PARAM NAME="EnableRefreshButton" VALUE=1>
<PARAM NAME="EnableGroupTree" VALUE=1>
<PARAM NAME="DisplayGroupTree" VALUE=1>
<PARAM NAME="EnablePrintButton" VALUE=1>
<PARAM NAME="EnableExportButton" VALUE=1>
<PARAM NAME="EnableDrillDown" VALUE=1>
<PARAM NAME="EnableSearchControl" VALUE=1>
<PARAM NAME="EnableAnimationControl" VALUE=1>
<PARAM NAME="EnableZoomControl" VALUE=1>
</OBJECT>
<SCRIPT LANGUAGE="VBScript">
<!--
Sub window_onLoad()
    Page_Initialize()
End Sub
Sub Page_Initialize
    On Error Resume Next
    Dim webBroker
    Set webBroker =
 CreateObject("WebReportBroker.WebReportBroker")
    URL = Location.Href
    if InStr(1, URL, "?")>0 then
        URL=Mid(URL, 1, InStr(1, URL, "?") - 1)
    end if
    if ScriptEngineMajorVersion < 2 then
        window.alert "IE 3.02 users on NT4 need to get the
latest version of VBScript or install IE 4.01 SP1. IE
3.02 users on Win95 need DCOM95 and latest version of
VBScript, or install IE 4.01 SP1. These files are
available at Microsoft's web site."
        CRViewer.ReportName = URL
    else
        Dim webSource
        Set webSource =
CreateObject("WebReportSource.WebReportSource")
        webSource.ReportSource = webBroker
        webSource.URL = URL
        webSource.PromptOnRefresh = True
        CRViewer.ReportSource = webSource
    end if
    CRViewer.ViewReport
End Sub
-->
</SCRIPT>

This example displays a Group Tree to allow Smart Navigation. Additionally, the user can drill-down on summary reports, refresh report data, and print the report to a printer.

For information on using the ActiveX viewer inside other applications and development environments, refer to the Seagate Crystal Reports Technical Reference Guide.


Report Viewer for Java using browser JVM

The Report Viewer for Java is a standard Java applet that can be placed inside an HTML page and viewed through any browser that supports Java. Netscape Navigator (version 4.0 and later) displays reports using the Report Viewer for Java by default.

Note: The Report Viewer for Java supports only single and double line objects.


Adding the Viewer to a web page

As a Java applet, the Report Viewer can be added to a web page using the standard HTML tag APPLET. The name of the public class exposed by the applet is Report Viewer. Thus, the following code displays the Report Viewer for Java:

<APPLET CODE="ReportViewer.class"
CODEBASE="http://<domain>/viewer/JavaViewer"
WIDTH=600 HEIGHT=400>
</APPLET>

When you install Seagate Crystal Reports or the Crystal Web Component Server, the Java viewer is installed under:

\Program Files\Seagate Software\Viewers\JavaViewer

Additionally, a virtual directory named

/viewer

is set up on your web server, which points to the

\Program Files\Seagate Software\Viewers

The Report Viewer for Java provides several optional parameters to customize the look of the viewer and to control its functionality. Apply values to these parameters using the standard PARAM tag in your HTML code.


Parameters

The Report Viewer for Java provides the following parameters:

CanDrillDown

Indicates whether or not the user can drill-down on summary data, graphs, or charts in the report.

  • TRUE allows drill-down.
  • FALSE prevents drill-down.
HasExportButton

Indicates whether or not an Export button appears on the Report Viewer. The export button allows users to export reports displayed in the Report Viewer to Microsoft Word, Microsoft Excel, HTML 3.2, or Seagate Crystal Reports format.

  • TRUE allows exporting.
  • FALSE prevents exporting.

To override this setting use the Crystal Report Web Components Manager application. For more information, refer to the Report Viewing tab.

HasGroupTree

Indicates whether or not the viewer generates a Group Tree for the report. Does not indicate whether or not the Group Tree is displayed.

  • TRUE generates a Group Tree.
  • FALSE prevents generation of a Group Tree.
HasPrintButton

Indicates whether or not the viewer includes a print button allowing the viewed report to be printed.

  • TRUE allows printing.
  • FALSE prevents printing.

Printing from the Report Viewer for Java requires a web browser or Java Virtual Machine that supports version 1.1 or later of the Java Developer's Kit (JDK).

HasRefreshButton

Indicates whether or not a Refresh button is available in the viewer to allow the user to refresh report data.

  • TRUE allows users to refresh report data.
  • FALSE prevents users from refreshing report data.
HasTextSearchControls

Indicates that the viewer includes controls to allow searching for specific values in the report.

  • TRUE allows searching.
  • FALSE prevents search controls from being displayed.
ReportName

Specifies the report to be displayed inside the viewer. The path must be a URL on the same server as the HTML document and must be placed inside quotation marks.

ShowGroupTree

Indicates whether or not the Group Tree is displayed when the viewer first appears. If the HasGroupTree parameter is set to False, this parameter is ignored. If the Group Tree is hidden, the user can display it by clicking the Toggle Group Tree button in the viewer.

  • TRUE displays the Group Tree.
  • FALSE hides the Group Tree.
Example

The following code demonstrates one means of embedding the Report Viewer for Java in a web page. This JavaScript code determines browser version and then installs the appropriate version of the Report Viewer for Java.

<SCRIPT LANGUAGE="JavaScript"><!--
var _ns3 = false;
var _ns4 = false;
//--></SCRIPT>
<COMMENT><SCRIPT LANGUAGE="JavaScript1.1"><!--
var _info = navigator.userAgent;
var _ns3 = (navigator.appName.indexOf("Netscape") >= 0 &&
_info.indexOf("Mozilla/3") >= 0);
var _ns4 = (navigator.appName.indexOf("Netscape") >= 0 &&
_info.indexOf("Mozilla/4") >= 0 );
//--></SCRIPT></COMMENT>
<SCRIPT LANGUAGE="JavaScript"><!--
if(_ns3==true)
document.writeln( '<applet
code=com.seagatesoftware.img.ReportViewer.ReportViewer
codebase="/viewer/JavaViewer" id=ReportViewer width=100% height=95%
archive="/viewer/JavaViewer/ReportViewer.zip">' );
else if (_ns4 == true)
document.writeln( '<applet
code=com.seagatesoftware.img.ReportViewer.ReportViewer
codebase="/viewer/JavaViewer" id=ReportViewer width=100% height=95%
archive="/viewer/JavaViewer/ReportViewer.jar">' );
else
document.writeln( '<applet
code=com.seagatesoftware.img.ReportViewer.ReportViewer
codebase="/viewer/JavaViewer" id=ReportViewer width=100% height=95%>'
);
//--></SCRIPT>
<param name=Language value="en">
<param name=ReportName value="empprof.rpt">
<param name=ReportParameter value="">
<param name=HasGroupTree value="true">
<param name=ShowGroupTree value="true">
<param name=HasRefreshButton value="true">
<param name=HasPrintButton value="true">
<param name=HasExportButton value="true">
<param name=HasTextSearchControls value="true">
<param name=CanDrillDown value="true">
<param name=PromptOnRefresh value="true">
<param name=cabbase value="/viewer/JavaViewer/ReportViewer.cab">
</applet>

This example displays the empprof.rpt report in the Report Viewer for Java window. A Group Tree is generated to allow Smart Navigation, but it will be hidden initially. The viewer does not allow a user to refresh the report data.


Report Viewer for Java using Java Plug-in

The Report Viewer for Java using Java Plug-in supports Netscape 4.0 and higher, as well as Internet Explorer 3.02 and higher.

Note: The Report Viewer for Java using Plug-in supports only single and double line objects.


Report Viewer for Netscape Plug-in

The Report Viewer for Netscape Plug-in supports Netscape Navigator 4.0 and higher.

Note: The Report Viewer for Plug-in supports only single and double line objects.


Report Viewers for HTML

There are two different HTML Report Viewers. There is a Report Viewer for Standard HTML with Frames and a Report Viewer for Standard HTML. Both are based on the HTML standards defined by the World Wide Web Consortium (W3C).

The primary difference between the two Viewers is that the Report Viewer for Standard HTML with Frames allows a Group Tree to be displayed in a separate frame to the left of the report. This Group Tree works like the Group Tree in the Preview tab of the Report Designer. The remainder of this section applies to both HTML Report Viewers.


HTML report limitations

Since HTML 3.2 format does not provide all of the formatting features available in the Seagate Crystal Reports report format, translating reports to HTML introduces several limitations. The limitations are outlined below.


Object layout/positioning

HTML 3.2 translation preserves relative positioning of objects and fields. However, absolute positioning, height, and width is browser dependent.


Objects translated

Object | Translated/Not Translated
Field Objects | Yes
Text Objects | Yes
Graphic, Blob, Chart Objects | Yes, as JPEG images.
OLE Objects | Yes, as JPEG images.
Cross-Tab Objects | Yes
Subreport Objects | Yes
On-demand subreports | No
Map objects | Yes, as JPEG images
Line and Box Objects | Yes with DHTML

Note: HTML 4.0 supports only single and double line objects.


Overlayed report objects

HTML 3.2 does not support overlaying. Report objects which are partially overlayed (even a tiny fraction) appear alongside each other.


Report object borders

If all 4 sides of the object have a border, an HTML box is drawn around the report object.

If either a bottom or top side of the object has a border, an HTML horizontal rule is drawn above or below the object accordingly (lone vertical borders are not translated).

Dotted lines appear as solid lines.

Double lines appear as thick solid lines.

Drop shadows appear as a box drawn around the report object.

If the Tight Horizontal option is selected, HTML box width is the approximate "width of report object" or "width of data."

If the Tight Horizontal option is not selected, HTML horizontal rule width is the "width of report object."


Drill-down

Group drill-down is supported.

Chart drill-down is not supported.

Map drill-down is not supported.


Product Support

This section provides you with information about how to contact Seagate Software to register your product and how to obtain technical support. It also includes details about our product return and replacement policies.


Product registration

When using Seagate Crystal Reports for the first time, a dialog box appears that asks for your name, address, and related information. Then you are prompted to register the product to receive your Registration Number.

Registration methods:

  • If you have access to the Internet, fill out the Product Registration form on the Seagate Software web site at:

    http://www.seagatesoftware.com/register

    Or access the form from the Help menu by clicking Register/Change Address.

  • Print the Product Registration form and then fax it to the Registration Fax number closest to you. Seagate will then fax back to you a registration number that can be entered into the product the next time you use it.

    Registration Fax Numbers

    USA/Canada +1 (604) 681-5147
    United Kingdom +44 (0) 181 231 0649
    Australia +6 2 9955 7682
    Hong Kong +852 2893 2727
    Singapore +65 777 8786

  • Fill out the Registration Form and mail it to Seagate Software. Seagate will mail a registration number back to you to enter into the product.

Registering the program will ensure that you are kept up-to-date with product advancements, and it will enable Seagate to provide quality technical support to people that are properly registered with Seagate Software.

When you enter the Registration Number, you have completed the registration process.


Product support

Seagate Software is proud of the quality of its product and has spent a great deal of time trying to make it intuitive to use. If, however, you need assistance with something, consult the online Help system. The Help system can be accessed by clicking any Help button, by pressing the F1 key, or by selecting an option from the Help Menu. The Help system contains all of the information from the User's Guide, as well as in-depth explanations and examples of all the reporting concepts.

Note: Product support plans vary from region to region. Contact your Seagate Software Office/Distributor for a list of product support plans available in your region.

See Seagate Software International Office Directory for a list of Seagate Software International Offices.


Web support

Seagate Software Web site

To connect to the Seagate Software web site
  1. Click Help.
  2. Select Seagate Software on the Web.
  3. Click Seagate Software Home Page.

Or enter the following address into your web browser:

http://community.seagatesoftware.com

Note: "community" replaces "www" in the web address.


Seagate Software Product Support

The Seagate Software Product Support web page provides a number of different support methods. These include Answers by Email, Files and Updates, Forums, and the Seagate Knowledge Base.

To connect to the Seagate Software Product Support web page
  1. Click Help.
  2. Select Seagate Software on the Web.
  3. Click Online Support.

Or enter the following address into your web browser:

http://community.seagatesoftware.com/support

Note: "community" replaces "www" in the web address.


Email support

Email

  • answers@seagatesoftware.com

To submit a Technical Support issue by email:

  • Email a blank message to the address above. Leave everything blank and the system will send you back a form to complete.
Newsletter Service

  • http://community.seagatesoftware.com/myprofile/subscribe.asp
      • Seagate Software's Newsletter Service provides subscribers with information about product updates, current events, and new product releases.
      • Each product you select will add your email address to that particular topic's newsletter group. You may select multiple products and you may select both marketing and technical information. You will then see a confirmation page that simply asks you to verify your information. You may unsubscribe from any list at any time.


Fax support

Another efficient way to receive support for Seagate Crystal Reports is to fax your technical support request. To do this, first fill in the bottom part of the Technical Support Request form included with the product. This form appears when you choose the Technical Support Request from the Help Menu. When you have completed the form, click Print Request to print it.

Fax the completed form to Seagate Software at +1 (604) 681-7163. This service is available Monday through Friday (24 hours a day).

After a technical product specialist has had a chance to review your fax, they will respond to you by return fax the next business day.


Technical support

Seagate Software offers several levels of telephone support for Seagate Crystal Reports.

Priority Technical Support

Seagate Crystal Reports Priority Technical Support is designed to get you priority-queue response while saving you money on long-distance calling fees.

  • Money-Saving Toll-Free Number**
  • Priority-Call Response
  • Extended Calling Hours**
  • Online Services for 24-Hour Support
  • Affordable One-Year Contract.

Money-Saving Toll-Free Number**

Get unlimited access to a toll-free number and save money on expensive long-distance calling times.

Priority-Call Response

We guarantee the fastest possible response times for Priority Support incidents. All Priority Support calls take precedent over Standard Support calls.

Extended Calling Hours**

Extended calling hours ensure you can get the answers you need, at the right time. We offer extended calling hours Monday to Friday from 8:00am - 8:00pm EST.

Online Services for 24-Hour Support

Seagate Software provides the tools for you to independently get fast answers to technical questions. We have a number of online services for unlimited email and web-based support, 24 hours a day, 7 days a week.

Affordable One-Year Contract

Sign-up for Seagate Crystal Reports Priority Support for a one-year contract from the date of purchase.

**Availability of toll-free numbers and extended calling hours varies by region.

Contacting Us

For more information, or to purchase Seagate Crystal Reports Priority Support, visit our web site at http://www.seagatesoftware.com or contact us at the office nearest you.

Canada/USA: 1-800-877-2340 or 1-604-681-3435

Europe/Middle East/Africa: +44-181-566-2330

Asia/Pacific: +61-2-9955-4088


Standard Technical Support

Seagate Software provides customers with free phone, email and fax support for Seagate Crystal Reports users during regular business hours, Monday through Friday. Standard Support is free* to all registered users. We encourage you to register your product to ensure you have timely access to our technical support services.

*Free technical support is available for the first 60 days from the date of purchase.

Location | Days | Times
North America +1 (604) 669-8379 | M-F | 11:00am - 7:00pm EST
Austria + 43 (0) 1 79 5672 85 | M-F | 9:30am - 5:00pm CET
Belgium + 32 (0) 2 713 12 35 | M-F | 9:30am - 5:00pm CET
France +33 (0) 141 918630 | M-F | 9:30am - 5:00pm CET
Germany +49 (0) 699 509 6180 | M-F | 9:30am - 5:00pm CET
Ireland + 353 (0) 1 407 30 30 | M-F | 9:00am - 4:00pm GMT
Netherlands + 31 (0) 20 346 9201 | M-F | 10:00am - 5:00pm CET
Sweden + 46 (0) 85 87 711 45 | M-F | 10:00am - 5:00pm CET
Switzerland (German) + 41 (0) 1 800 9134 | M-F | 9:30am - 5:00pm CET
Switzerland (French) + 41 (0) 1 800 9130 | M-F | 9:30am - 5:00pm CET
UK +44 (0) 181 231 0638 | M-F | 9:00am - 4:00pm GMT

Note: Long-distance charges may apply. Telephone numbers vary with location.

If you are calling from Africa or the Middle East, see Seagate Software International Office Directory to find out the telephone number of the support office closest to you.

If the country you are calling from is not listed above call the North American Standard Technical Support number at +1 (604) 669-8379.

Please have the following information available:

  • Product registration number.

    If you are registered, you can find the product registration number by choosing About Crystal Report Designer from the Help Menu.

    If you are not registered, you will need to register to obtain the product registration number.

  • Product name and version number.

    From the Help menu, click About Seagate Crystal Reports.

  • Operating system you are using.

    For example, Windows 95, Windows 98, or Windows NT.

  • Version of the database and other software you are using with Seagate Crystal Reports (if required).

    Access, Btrieve, SQL, Sybase, Paradox, etc.

  • Network information, if you are on a network.
  • Contents of AUTOEXEC.BAT and CONFIG.SYS files.
  • The list of steps necessary to recreate the problem.
  • The programming environment (if applicable).


Seagate Knowledge Link

Our Seagate Software Technical Product Specialists have created the Seagate Knowledge Link - our searchable database of technical reference articles. Shipped on CD, this application includes a base library of articles that can help new and experienced users resolve current technical issues. Seagate Knowledge Link includes 12 months of regular Technotes delivered bi-weekly via email.

Contacting Us

For more information, or to purchase Seagate Knowledge Link, visit our web site at http://www.seagatesoftware.com or contact us at the office nearest you.

Canada/USA: 1-800-877-2340 or 1-604-681-3435

Europe/Middle East/Africa: +44-181-566-2330

Asia/Pacific: +61-2-9955-4088

See Seagate Software International Office Directory to find out the telephone number of the sales office closest to you.


Product return policy

If you are not satisfied with Seagate Crystal Reports for any reason, you can return it to the original place of purchase for a refund within 30 days of the purchase date.


Product replacement policy

If your Seagate Crystal Reports CD or documentation is defective, then please contact Seagate Software, Inc., within 30 days of the purchase date. Fax a description of the problem and Seagate will solve it as quickly as possible. Please fax the description of the defect to +1 (604) 681-2934.

Note: Replacement policies vary from region to region. Contact your local distributor for a list of replacement policies available in your region.


Seagate Software International Office Directory

This section lists the contact information for Sales, Product Support, and Product Registration at each Seagate Software office, worldwide.


North/South American Head Office

Canada & USA

Seagate Software, Inc.

840 Cambie Street

Vancouver, BC V6B 4J2

Canada

Sales

Telephone: 604-681-3435

Toll-Free: 1-800-877-2340

Fax: 604-681-2934

Email: sales@seagatesoftware.com

Product support

Phone: 604-669-8379

Fax: 604-681-7163

Email: answers@seagatesoftware.com (Available in English only)

Web browser: http://community.seagatesoftware.com/support
(Available in English only)

Note: "community" replaces "www" in the web address.

Product registration

Fax: 604-681-5147

Email: answers@seagatesoftware.com

Web registration: http://www.seagatesoftware.com/register


Latin America

Seagate Software, Inc.

Suite 270 - 510 Thornall Street

Edison, NJ 08837

USA

Sales

Telephone: 732-321-6500

Fax: 732-321-6504

Product support

Please see the Product Support section listed under Canada.

Product registration

Please see the Product Registration section listed under Canada.


Asia/Pacific Offices

Australia

Seagate Software Pty Ltd.

Level 4, 60 Albert Road

South Melbourne, VIC 3205

Australia

Sales

Telephone: +61 2 9955 4088

Sales: +1-800-647-006

Fax: +61 2 9955 7682

Product support

Please see the Product Support section listed under Canada.

Product registration

Fax: +61 2 9955 7692

Online registration: please see the product registration section listed
under Canada.


Hong Kong

Seagate Software (HK)

Suite 2603, 26th Floor

Universal Trade Center

3 Arbuthnot Road, Central

Hong Kong

Sales

Telephone: +852 2575 2576

Fax: +852 2893 2727

Product support

Please see the Product Support section listed under Canada.

Product registration

Online registration: please see the product registration section listed
under Canada.


Japan

Seagate Software KK

Bridgestone Bldg. 2F

2-13-12 Hirakawa-cho,

Chiyoda-Ku,

Tokyo 102-0093

Sales

Telephone: +81. 3. 5226. 3601

Fax: +81. 3. 5226. 3606

Email: sales_jp@img.seagatesoftware.com

Product support

Fax support: +81.3.5226.3605

Support email: support_jp@img.seagatesoftware.com

Product registration

Fax registration: +81.3.5226.3605

Email: answers@seagatesoftware.com

Web registration: http://www.seagatesoftware.com/register


Singapore

Seagate Software IMG

14 Science Park Drive

03-02 The Maxwell

Singapore Science Park

Singapore 118226

Sales

Telephone: +65 777 0533

Fax: +65 777 8786

Product support

Please see the Product Support section listed under Canada.

Product registration

Online registration: please see the product registration section listed
under Canada.


Europe/Middle East/Africa Offices

United Kingdom - EMEA and Northern European Head Office

Seagate Software

The Broadwalk

54 The Broadway

Ealing, London

W5 5JN

UK

Sales

Telephone: +44 (0) 181 566 2330

Fax: +44 (0) 181 231 0600

Product support

Country | Telephone | Language
UK | +44 (0) 181 231 0638 | English
Austria | + 43 (0) 1 79 5672 85 | German
Switzerland | + 41 (0) 1 800 9134 | German
Switzerland | + 41 (0) 1 800 9130 | French
Belgium | + 32 (0) 2 713 12 35 | French
Netherlands | + 31 (0) 20 346 9201 | English
Ireland | + 353 (0) 1 407 30 30 | English
Sweden | + 46 (0) 85 87 711 45 | English

Fax: +44 (0) 181 231 0600 (English, German, French)

Email: answers@seagatesoftware.com (available in English only).

Web browser: http://community.seagatesoftware.com/support
(available in English only).

Note: "community" replaces "www" in the web address.

Product registration

Fax: + 44 (0) 181 231 0649

Email: answers@seagatesoftware.com

Web registration: http://www.seagatesoftware.com/register


Scotland

Seagate Software IMG

The Station Master's Office

Dalmeny Station

South Queensferry West

Lothian

EH30 9JP

Scotland

Sales

Telephone: +44 (0) 1506 410444

Fax: +44 (0) 1506 414994

Product support

Please see the Product Support section listed under Northern European
Head Office.

Product registration

Online registration: please see the product registration section listed under Northern Europe.


Sweden

Seagate Software

Kanalvagen 10C

194 61 Upplands Vasby

Sweden

Sales

Telephone: +46 8 590 04150

Fax: +46 8 590 04110

Product registration

Please see the Product Registration section listed under Northern European Head Office.

Online registration: please see the product registration section listed under Northern Europe.


Netherlands

Seagate Software

Hojel City Center

Gebuw D, 4e etage

Graadt van Roggenweg 328

Postbox 19127

3501 DC Utrecht

The Netherlands

Sales

Telephone: +31 30 298 2124

Fax: +31 30 298 2125

Product support

Please see the Product Support section listed under Northern European
Head Office.

Product registration

Online registration: please see the product registration section listed under Northern Europe.


Germany - Central European Head Office

Seagate Software GmbH

2nd Floor

Frankfurter Strasse 21-25

D-65760 Eschborn

Germany

Sales

Telephone: +49 (0) 6196 9559 0

Fax: +49 (0) 6196 9559 10

Product support

Telephone: +49 (0) 699 509 6180

Email: answers@seagatesoftware.com (Available in English only)

Web browser: http://community.seagatesoftware.com/support
(Available in English only)

Product registration

Fax: +49 (0) 6995 09 6182

Web browser: http://www.seagatesoftware.com/register


Switzerland

Seagate Software GmbH

World Trade Center

PO Box 112

Leutschenbachstrasse 95

CH-8050 Zurich

Switzerland

Sales

Telephone: +41 1 308 3922

Fax: +41 1 308 3500

Product support

Please see the Product Support section listed under Central European
Head Office.

Product registration

Fax: +49 (0) 6995 09 6182

Online registration: please see the product registration section listed under Central Europe.


France - Southern European Head Office

Seagate Software

62 bis, avenue Andre Morizet

F-92643 Boulogne Billancourt

Cedex

France

Sales

Telephone: +33 (0) 1 41 10 1600

Fax: +33 (0) 1 46 04 7419

Product support

Telephone: +33 (0) 141 918630

Fax +44 (0) 181 231 0600

Email: answers@seagatesoftware.com (Available in English only)

Web browser: http://community.seagatesoftware.com/support
(Available in English only)

Product registration

Fax: ++ 33 (0) 1 41 91 86 27

Web browser: http://www.seagatesoftware.com/register


Spain

Seagate Software IMG

Paseo de la Castellana 93 -4a

28046, Madrid

Spain

Sales

Telephone: +3491 555 5198

Fax: +3491 555 9957

Product support

Please see the Product Support section listed under Southern European
Head Office.

Product registration

Online registration: please see the product registration section listed under Southern Europe.


Italy

Seagate Software S.r.l.

Via Conservatorio 22

Milan 20122

Italy

Sales

Telephone: +39 02 7729 310

Fax: +39 02 7729 40

Product support

Please see the Product Support section listed under Southern European Head Office.

Product registration

Online registration: please see the product registration section listed under Southern Europe.


South Africa Regional Office (Southern & Central Africa)

Seagate Software IMG

Lower Ground Floor

Block F, Pin Mill Farm

164 Katherine Street

Sandton

PO Box 786050

Sandton, 2146

Republic of South Africa

Sales

Telephone: +27 11 448 2080

Fax: +27 11 448 1960

Product support

Run locally in Johannesburg.

Telephone: +27 11 448 2080

Fax: +27 11 448 1960 Contact: Ross Harrison

Email: rossh@seagatesa.co.za

Email: answers@seagatesoftware.com (Available in English only)

Web browser: http://community.seagatesoftware.com/support
(Available in English only)

Note: "community" replaces "www" in the web address.

Product registration

Online registration: please see the product registration section listed under Northern Europe.


Middle East Regional Office (ME & Northern Africa)

Seagate Software

PO Box 8687

Dubai

United Arab Emirates

Sales

Telephone: +971 4 523888

Fax: +971 4 519056

Product support

Run locally in Dubai.

Telephone: +971 4 523888 Contact: Katia Boueiri

Fax: +971 4 519056 Contact: Katia Boueiri

Email: kboueiri@img.seagatesoftware.com

Email: answers@seagatesoftware.com (Available in English only)

Web browser: http://community.seagatesoftware.com/support
(Available in English only)

Note: "community" replaces "www" in the web address.

Product registration

Online registration: please see the product registration section listed under Northern Europe.